diff --git a/src/backend/utils/adt/ruleutils.c b/src/backend/utils/adt/ruleutils.c
index 6c656586e8..b64235ef69 100644
--- a/src/backend/utils/adt/ruleutils.c
+++ b/src/backend/utils/adt/ruleutils.c
@@ -4829,6 +4829,12 @@ make_ruledef(StringInfo buf, HeapTuple ruletup, TupleDesc rulettc,
 		deparse_context context;
 		deparse_namespace dpns;
 
+        if (actions == NIL)
+			ereport(ERROR,
+					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					 errmsg("rule \"%s\" with event qualification \"%s\", need has actions",
+							rulename, ev_qual)));
+
 		if (prettyFlags & PRETTYFLAG_INDENT)
 			appendStringInfoString(buf, "\n  ");
 		appendStringInfoString(buf, " WHERE ");
